## newpid 2

=== Makefile ===
CFLAGS += -g -O2 -Wall -Werror
PREFIX = /usr

all: newpid newpid.1

newpid: newpid.o

newpid.1: newpid.pod
	pod2man --center "" -r "" --quotes=none --section 1 $< > $@

install: newpid newpid.1
	install -d $(DESTDIR)$(PREFIX)/bin
	install newpid $(DESTDIR)$(PREFIX)/bin/newpid
	install -d $(DESTDIR)$(PREFIX)/share/man/man1
	install newpid.1 $(DESTDIR)$(PREFIX)/share/man/man1/newpid.1

clean:
	rm -f newpid newpid.o newpid.1 z.out

=== debian/changelog ===
newpid (2) unstable; urgency=low

  * Add autopkgtest.
  * Enable build hardening.
  * Ignore errors on umount("/proc"), it could be busy.
  * Add manpage.

 -- Christoph Berg <christoph.berg@credativ.de>  Thu, 16 Jan 2014 12:51:32 +0100

newpid (1) UNRELEASED; urgency=low

  * Initial release.

 -- Christoph Berg <myon@debian.org>  Mon, 21 Jan 2013 22:48:32 +0100

=== debian/control ===
Source: newpid
Section: utils
Priority: optional
Maintainer: Debian PostgreSQL Maintainers <pkg-postgresql-public@lists.alioth.debian.org>
Uploaders: Christoph Berg <myon@debian.org>
Standards-Version: 3.9.5
Build-Depends: debhelper (>= 9~)
Vcs-Browser: https://github.com/ChristophBerg/newpid
Vcs-Git: git://github.com/ChristophBerg/newpid.git
XS-Testsuite: autopkgtest

Package: newpid
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: run a command in a new PID namespace
 newpid is a very simple wrapper around clone(CLONE_NEWPID) that launches a
 command in a new PID namespace. /proc is also remounted so it sees the new
 process space. Needs root to run.

=== debian/tests/control ===
Depends: @
Tests: zombie
Restrictions: needs-root

## newpid 4

=== debian/changelog ===
newpid (4) unstable; urgency=medium

  * Make /proc a slave mount as suggested by Lennart Poettering.

 -- Christoph Berg <christoph.berg@credativ.de>  Wed, 12 Mar 2014 13:30:05 +0100

newpid (3) unstable; urgency=medium

  * Remount /proc to be private so it doesn't break when running under systemd.
    Patch by Michael Stapelberg, thanks! (See #739593)
  * Use Arch: linux-any.

 -- Christoph Berg <christoph.berg@credativ.de>  Mon, 10 Mar 2014 15:18:41 +0100

=== debian/control ===
Source: newpid
Section: utils
Priority: optional
Maintainer: Christoph Berg <myon@debian.org>
Standards-Version: 3.9.5
Build-Depends: debhelper (>= 9~)
Vcs-Browser: https://github.com/ChristophBerg/newpid
Vcs-Git: git://github.com/ChristophBerg/newpid.git
XS-Testsuite: autopkgtest

Package: newpid
Architecture: linux-any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: run a command in a new PID namespace
 newpid is a very simple wrapper around clone(CLONE_NEWPID) that launches a
 command in a new PID namespace. /proc is also remounted so it sees the new
 process space. Needs root to run.

## newpid 4.pgdg12.4+1

=== debian/changelog ===
newpid (4.pgdg12.4+1) precise-pgdg; urgency=low

  * Rebuild for precise-pgdg (jenkins-newpid-source-
    distribution=precise-12, git revision
    39163b82fa6f579aab7983ab2bee160832ec7021)

 -- apt.postgresql.org autobuilder <myon@debian.org>  Wed, 12 Mar 2014 13:36:23 +0100

## newpid 4.pgdg14.04+1

=== debian/changelog ===
newpid (4.pgdg14.04+1) trusty-pgdg; urgency=low

  * Rebuild for trusty-pgdg (jenkins-newpid-source-distribution=trusty-
    12, git revision 39163b82fa6f579aab7983ab2bee160832ec7021)

 -- apt.postgresql.org autobuilder <myon@debian.org>  Wed, 12 Mar 2014 13:36:19 +0100

## newpid 4.pgdg+1

=== debian/changelog ===
newpid (4.pgdg+1) sid-pgdg; urgency=low

  * Rebuild for sid-pgdg (jenkins-newpid-source-distribution=sid-12, git
    revision 39163b82fa6f579aab7983ab2bee160832ec7021)

 -- apt.postgresql.org autobuilder <myon@debian.org>  Wed, 12 Mar 2014 13:36:11 +0100

## newpid 6.pgdg70%2B1

=== debian/changelog ===
newpid (6.pgdg70+1) wheezy-pgdg; urgency=medium

  * Rebuild for wheezy-pgdg (jenkins-newpid-source-distribution=wheezy-
    17, git revision f89b6d70f1c7f4b969dac5a492048851531da2fd)

 -- apt.postgresql.org autobuilder <myon@debian.org>  Sat, 10 Oct 2015 15:42:20 +0200

newpid (6) unstable; urgency=medium

  * Add support for CLONE_NEWIPC and CLONE_NEWUTS (newpid -iu), and have
    newnet use it.

 -- Christoph Berg <myon@debian.org>  Sat, 10 Oct 2015 15:38:21 +0200

newpid (5) unstable; urgency=medium

  * newpid -n uses CLONE_NEWNET to start a new network namespace.
  * Add "newnet" wrapper for "newpid -n".
  * Use setcap "CAP_SYS_ADMIN,CAP_NET_ADMIN=pe" /usr/bin/newpid.
  * Change license to GPL2+.

 -- Christoph Berg <christoph.berg@credativ.de>  Wed, 30 Sep 2015 16:26:55 +0200

## newpid 7

=== test/Makefile ===
check: check-zombie check-newnet

check-zombie:
	newpid ./zombie.pl 2>&1 | tee zombie.out
	if grep -q 'version code' zombie.out; then sed -i -e '1,/version code/d' zombie.out; fi # remove "Non-standard uts for running kernel" on lucid
	diff -u zombie.expected zombie.out

check-newnet:
	( newpid -n ping -q -c 1 -n 127.0.0.1 | sed -e 's/\(time\|rtt\).*//'; \
	  newpid -n ping -q -c 1 -n 192.0.2.1 \
	) 2>&1 | tee newnet.out
	diff -u newnet.expected newnet.out

clean:
	rm -f zombie.out newnet.out

=== debian/changelog ===
newpid (7) unstable; urgency=medium

  * Add support for joining network namespaces (newpid -N).

 -- Christoph Berg <christoph.berg@credativ.de>  Wed, 23 Dec 2015 11:33:12 +0100

=== debian/control ===
Source: newpid
Section: utils
Priority: optional
Maintainer: Christoph Berg <myon@debian.org>
Standards-Version: 3.9.6
Build-Depends: debhelper (>= 9~)
Vcs-Browser: https://github.com/ChristophBerg/newpid
Vcs-Git: git://github.com/ChristophBerg/newpid.git
XS-Testsuite: autopkgtest

Package: newpid
Architecture: linux-any
Depends: libcap2-bin, ${shlibs:Depends}, ${misc:Depends}
Description: run a command in a new PID namespace
 newpid is a simple suid wrapper around clone(CLONE_NEWPID) that launches a
 command in a new PID namespace. Optionally it can also use CLONE_NEWNET to
 request a new network namespace.

## newpid 7ubuntu1

=== debian/changelog ===
newpid (7ubuntu1) zesty; urgency=medium

  * If setcap fails (because the filesystem or namespace lacks support for
    capabilities), fall back to setuid, so the installation doesn't fail.

 -- Adam Conrad <adconrad@ubuntu.com>  Tue, 04 Apr 2017 03:05:19 -0600

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: newpid
 Section: utils
 Priority: optional
-Maintainer: Christoph Berg <myon@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Christoph Berg <myon@debian.org>
 Standards-Version: 3.9.6
 Build-Depends: debhelper (>= 9~)
 Vcs-Browser: https://github.com/ChristophBerg/newpid

## newpid 8

=== debian/changelog ===
newpid (8) unstable; urgency=medium

  * If setcap fails (because the filesystem or namespace lacks support for
    capabilities), fall back to setuid, so the installation doesn't fail.
    Thanks to Adam Conrad for the patch! Closes: #860031
  * newpid: More verbose usage output.
  * newnet: Guard arguments with --.
  * README: Note required kernel and glibc version.
  * Bump Standards-Version.

 -- Christoph Berg <myon@debian.org>  Mon, 01 May 2017 18:15:30 +0200

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,8 @@
 Source: newpid
 Section: utils
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Christoph Berg <myon@debian.org>
-Standards-Version: 3.9.6
+Maintainer: Christoph Berg <myon@debian.org>
+Standards-Version: 3.9.8
 Build-Depends: debhelper (>= 9~)
 Vcs-Browser: https://github.com/ChristophBerg/newpid
 Vcs-Git: git://github.com/ChristophBerg/newpid.git

## newpid 8.pgdg16.04+1

=== debian/changelog ===
newpid (8.pgdg16.04+1) xenial-pgdg; urgency=medium

  * Rebuild for xenial-pgdg (jenkins-newpid-source-distribution=xenial-
    21, 73b2c1d7c3f822d9e2d11f6ca62d083723695c04/git)

 -- apt.postgresql.org autobuilder <pgsql-pkg-debian@postgresql.org>  Sat, 20 May 2017 20:31:53 +0200

## newpid 9

=== debian/changelog ===
newpid (9) unstable; urgency=medium

  [ James Clarke ]
  * Use __clone2 on ia64 as it has no clone.

  [ Christoph Berg ]
  * Bump to DH 11.

 -- Christoph Berg <christoph.berg@credativ.de>  Tue, 09 Jan 2018 10:41:56 +0100

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: utils
 Priority: optional
 Maintainer: Christoph Berg <myon@debian.org>
-Standards-Version: 3.9.8
-Build-Depends: debhelper (>= 9~)
+Standards-Version: 4.1.3
+Build-Depends: debhelper (>= 11~)
 Vcs-Browser: https://github.com/ChristophBerg/newpid
 Vcs-Git: git://github.com/ChristophBerg/newpid.git
 XS-Testsuite: autopkgtest

## newpid 10

=== debian/changelog ===
newpid (10) unstable; urgency=medium

  * newnet.pod: Fix typo "netpid".

 -- Christoph Berg <christoph.berg@credativ.de>  Mon, 18 Feb 2019 14:11:35 +0100

## newpid 10+nmu1

=== debian/changelog ===
newpid (10+nmu1) unstable; urgency=medium

  * Non-maintainer upload.
  * rebuild for mstrict-align

 -- root <root@loongson-pc>  Fri, 28 Jan 2022 16:20:20 +0800

## newpid 11

=== test/Makefile ===
--- 
+++ 
@@ -1,3 +1,6 @@
+# output error messages in English
+export LC_MESSAGES=C
+
 check: check-zombie check-newnet
 
 check-zombie:
@@ -6,9 +9,11 @@
 	diff -u zombie.expected zombie.out
 
 check-newnet:
-	( newpid -n ping -q -c 1 -n 127.0.0.1 | sed -e 's/\(time\|rtt\).*//'; \
-	  newpid -n ping -q -c 1 -n 192.0.2.1 \
-	) 2>&1 | tee newnet.out
+	# remove time/rtt output for reproducibility
+	# iputils-ping 3:20190515-2 added a "ping: " prefix in front of errors, remove it for compatibility
+	( newpid -n ping -q -c 1 -n 127.0.0.1 2>&1 | sed -e 's/\(time\|rtt\).*//'; \
+	  newpid -n ping -q -c 1 -n 192.0.2.1 2>&1 | sed -e 's/^ping: //' \
+	) | tee newnet.out
 	diff -u newnet.expected newnet.out
 
 clean:

=== debian/changelog ===
newpid (11) unstable; urgency=medium

  * Update testsuite for changed "ping" output in iputils-ping 3:20190515-2.
    Closes: #931648

 -- Christoph Berg <myon@debian.org>  Mon, 15 Jul 2019 15:17:16 +0200

## newpid 12

=== test/Makefile ===
--- 
+++ 
@@ -6,7 +6,7 @@
 check-zombie:
 	newpid ./zombie.pl 2>&1 | tee zombie.out
 	if grep -q 'version code' zombie.out; then sed -i -e '1,/version code/d' zombie.out; fi # remove "Non-standard uts for running kernel" on lucid
-	diff -u zombie.expected zombie.out
+	diff -ub zombie.expected zombie.out
 
 check-newnet:
 	# remove time/rtt output for reproducibility

=== debian/changelog ===
newpid (12) unstable; urgency=medium

  [ Balint Reczey ]
  * test: Ignore space changes in ps' output.

  [ Christoph Berg ]
  * debian/gitlab-ci.yml: Use standard Salsa CI pipeline.

 -- Christoph Berg <myon@debian.org>  Mon, 15 Jul 2019 16:11:01 +0200

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,10 @@
 Section: utils
 Priority: optional
 Maintainer: Christoph Berg <myon@debian.org>
-Standards-Version: 4.1.3
+Standards-Version: 4.4.0
 Build-Depends: debhelper (>= 11~)
-Vcs-Browser: https://github.com/ChristophBerg/newpid
-Vcs-Git: git://github.com/ChristophBerg/newpid.git
-XS-Testsuite: autopkgtest
+Vcs-Browser: https://github.com/df7cb/newpid
+Vcs-Git: https://github.com/df7cb/newpid.git
 
 Package: newpid
 Architecture: linux-any

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

override_dh_auto_install:
	$(MAKE) install PREFIX=/usr DESTDIR=$(CURDIR)/debian/newpid

override_dh_auto_test:
	# skipping test at build time, needs packages installed

%:
	dh $@

=== debian/tests/control ===
Depends: @, iputils-ping
Tests: check

## newpid 13

=== Makefile ===
CFLAGS += -g -O2 -Wall -Werror
PREFIX = /usr/local

all: newpid newpid.1 newnet.1

newpid: newpid.o

%.1: %.pod
	pod2man --center "" -r "" --quotes=none --section 1 $< > $@

install: newpid newpid.1
	mkdir -p $(DESTDIR)$(PREFIX)/bin
	install -m 755 newpid $(DESTDIR)$(PREFIX)/bin/newpid
ifeq ($(DESTDIR),)
	setcap "CAP_SYS_ADMIN,CAP_NET_ADMIN=pe" $(DESTDIR)$(PREFIX)/bin/newpid
endif
	install -m 755 newnet $(DESTDIR)$(PREFIX)/bin/newnet
	mkdir -p $(DESTDIR)$(PREFIX)/share/man/man1
	install newpid.1 $(DESTDIR)$(PREFIX)/share/man/man1/newpid.1
	install newnet.1 $(DESTDIR)$(PREFIX)/share/man/man1/newnet.1

check:
	$(MAKE) -C test check

clean:
	rm -f newpid newpid.o newpid.1 newnet.1
	$(MAKE) -C test clean

=== debian/changelog ===
newpid (13) unstable; urgency=medium

  * Disable stackprotector on arm64, breaks clone().
  * debian/tests: Use Test-Command.

 -- Christoph Berg <myon@debian.org>  Tue, 07 Apr 2020 16:42:44 +0200

=== debian/tests/control ===
Depends: @, iputils-ping
Test-Command: make check
Features: test-name=check

## newpid 14

=== test/Makefile ===
--- 
+++ 
@@ -11,8 +11,8 @@
 check-newnet:
 	# remove time/rtt output for reproducibility
 	# iputils-ping 3:20190515-2 added a "ping: " prefix in front of errors, remove it for compatibility
-	( newpid -n ping -q -c 1 -n 127.0.0.1 2>&1 | sed -e 's/\(time\|rtt\).*//'; \
-	  newpid -n ping -q -c 1 -n 192.0.2.1 2>&1 | sed -e 's/^ping: //' \
+	( $(ROOTCMD) newpid -n ping -q -c 1 -n 127.0.0.1 2>&1 | sed -e 's/\(time\|rtt\).*//'; \
+	  $(ROOTCMD) newpid -n ping -q -c 1 -n 192.0.2.1 2>&1 | sed -e 's/^ping: //' \
 	) | tee newnet.out
 	diff -u newnet.expected newnet.out

=== debian/changelog ===
newpid (14) unstable; urgency=medium

  * ping is no longer suid root; run autopkgtest with sudo.
    Thanks Noah Meyerhans! (Closes: #1086014)

 -- Christoph Berg <myon@debian.org>  Sun, 10 Nov 2024 15:35:27 +0100

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,9 @@
 Section: utils
 Priority: optional
 Maintainer: Christoph Berg <myon@debian.org>
-Standards-Version: 4.4.0
-Build-Depends: debhelper (>= 11~)
+Standards-Version: 4.5.0
+Build-Depends:
+ debhelper-compat (= 12),
 Vcs-Browser: https://github.com/df7cb/newpid
 Vcs-Git: https://github.com/df7cb/newpid.git

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,11 @@
 #!/usr/bin/make -f
 
+include /usr/share/dpkg/architecture.mk
+
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+ifeq ($(DEB_HOST_ARCH),arm64)
+export DEB_CFLAGS_MAINT_APPEND = -fno-stack-protector
+endif
 
 override_dh_auto_install:
 	$(MAKE) install PREFIX=/usr DESTDIR=$(CURDIR)/debian/newpid

=== debian/tests/control ===
Depends: @, iputils-ping
Test-Command: make check ROOTCMD=sudo
Features: test-name=check
Restrictions: needs-sudo

## newpid 14build1

=== debian/changelog ===
newpid (14build1) resolute; urgency=medium

  * No-change mass rebuild for Ubuntu 26.04 (LP: #2132257)

 -- Graham Inggs <ginggs@ubuntu.com>  Mon, 26 Jan 2026 20:13:37 +0000
